
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char request[256];
char server[256];
char file[256];

int main (int argc,char **argv)

{
char *p;
int port;
FILE *tcp;
FILE *out;
int n;
long size;

if (argc != 3)
	{
	printf ("Usage: tcphttpget <url> <file>\n");
	return (10);
	}

if (strncmp (argv[1],"http://",7))
	{
	printf ("please enter a proper http url: http://server[:port]/file\n");
	return (10);
	}

p = strchr(&argv[1][7],'/');
if (p)
	{
	strcpy (file,p);
	*p = 0;
	strcpy (server,&argv[1][7]);
	}
else
	{
	strcpy (file,"/");
	strcpy (server,&argv[1][7]);
	}

p = strchr(server,':');
if (p)
	{
	*p++ = 0;
	port = atoi(p);
	}
else
	port = 80;

printf ("connecting to %s port %d to get %s\n",server,port,file);

sprintf (request,"tcp:%s/%d",server,port);

tcp = fopen(request,"rb+");
if (!tcp)
	{
	printf ("cannot connect to server\n");
	return (20);
	}

fprintf (tcp,"GET %s HTTP/1.0\n",file);
fputs ("\n",tcp);

fgets (request,256,tcp);
p = strchr(request,' ');
if (strncmp (p," 200 ",5))
	{
	fputs (request,stdout);
	fclose (tcp);
	return (20);
	}

while (fgets (request,256,tcp) && *request && *request != '\n' && *request != '\r');

out = fopen (argv[2],"wb");
if (!out)
	{
	printf ("cannot open output file\n");
	fclose (tcp);
	return (10);
	}

size = 0;
do	{
	n = fread (request,1,256,tcp);
	fwrite (request,1,n,out);
	size += n;
	}
while (!feof(tcp));

printf ("%d bytes read\n",size);

fclose (out);
fclose(tcp);
return (0);
}

